<template>
    <div class="department_input" @click="is_target=true">
        <div class="arrow wrap" @click="toggleDropdown">
            <div class="arrow target" :class="{opened: searchResultsVisible}"></div>
        </div>

        <input
            type="text"
            :value="value"
            :placeholder="placeholder"
            :disabled="disabled"
            :class="value_class"
            @input="$emit('input', $event.target.value); searchResultsVisible = true;$emit('refresh')"
            @focus="handleValueFocus"
            @blur="handleValueBlur"
        >
        <div class="lbl" :class="value?'not_empty':'empty'">{{placeholder}}</div>
        <div class="list-box-holder">
            <ul class="drop_list" v-if="searchResultsVisible && searchResults.length" v-click-outside="clickOutsideConfig">
                <li class="item"
                    v-for="department in searchResults"
                    @click="$emit('input', $event.target.innerText);searchResultsVisible = false;$emit('set-department',department);$emit('set-city',department);"
                >{{ department.department_no + ' ('+department.street_ua + ' ' +department.building_no +')' }}</li>
            </ul>
            <ul v-if='(!searchResults.length && searchResultsVisible)' style="max-height: 200px; overflow-y: scroll;">
                <li style="color: red;">
                    {{$t('message.nothing_was_found')}}
                </li>
            </ul>
        </div>
    </div>
</template>

<script>
    import vClickOutside from 'v-click-outside';

    export default {
        name: "DepartmentInput",
        props: ['value', 'placeholder', 'departments', 'disabled'],
        directives: {
            clickOutside: vClickOutside.directive
        },
        data() {
            return {
                selected: '',
                searchResultsVisible: false,
                is_target: false,
                value_class: '',
                clickOutsideConfig: {
                    handler: this.toggleDropdown,
                    middleware: this.clickOutsideMiddleware,
                    events: ['dblclick', 'click'],
                    isActive: true
                }
            };
        },
        computed: {
            searchResults() {
                let search = this.value.toString().toLowerCase();
                search = search.replace(/(вул|ул|у|в|улица|вулиця)(\.)?/g, '');
                search = search.trim();

                const searchFields = ['department_no', 'street_ru', 'street_ua'];
                const departments = this.value.length
                    ? this.departments.filter(department => {
                        let result = false;
                        searchFields.forEach(field => {
                            if( department[field].toString().toLowerCase().includes(search) ){
                                result = true;
                            }
                        });
                        return result;
                    })
                    : this.departments;

                return departments;
            },
            clicked() {
                return this.$store.getters.clicked;
            }
        },
        methods: {
            handleValueFocus () {
                this.value_class = 'hover';
            },
            handleValueBlur () {
                this.value_class = '';
            },
            toggleDropdown(){
                this.searchResultsVisible =! this.searchResultsVisible;
                this.$emit('input', '');
            },
            clickOutsideMiddleware (event) {
                return event.target.className !== 'arrow';
            }
        },
        watch: {
            clicked: function (v,o){
                if( this.searchResultsVisible && !this.is_target ) {
                    this.searchResultsVisible = false;
                }
                this.is_target = false;
            }
        }
    }
</script>
